import xml.dom.minidom
import gtk.glade
import gtk

def setlabel(widget, label):
    widget.get_child().set_text(label)
    
def getlabel(widget):
    return widget.get_child().get_text()

class ButtonLayout:
    def __init__(self, filename, widgettree, mainwindow,
                 object, firstlayout="main"):
        self.object = object
        self.tree = widgettree
        self.mainwindow = mainwindow
        self.dom = xml.dom.minidom.parse(filename)
        self.widgets = []
        self.layoutaction = False
        self.setlayout(firstlayout)

    def setlayout(self, layoutname):
        for layout in self.dom.getElementsByTagName("layout"):
            if layout.getAttribute("id") == layoutname:
                self.currentlayout = layout
                self.updatelayout()

    def getwidget(self, widgetnode):
        return gtk.glade.XML.get_widget(self.tree,
                                        widgetnode.getAttribute("id"))

    def evaltext(self, text, widget=None):
        return eval(text, {"self":self.object, "widget":widget})

    def exectext(self, text, widget=None):
        exec text in None, {"self":self.object, "widget":widget}

    def updatelayout(self):
        for widget in self.widgets:
            setlabel(widget, "")

        self.widgets = []
        for widgetnode in self.currentlayout.getElementsByTagName("widget"):
            widget = self.getwidget(widgetnode)
            if widget:
                self.widgets.append(widget)

                if widgetnode.hasAttribute("titleaction"):
                    title = self.evaltext(
                        widgetnode.getAttribute("titleaction"), widget)
                else:
                    title = widgetnode.getAttribute("title")

                setlabel(widget, title)

        if self.currentlayout.hasAttribute("action"):
            self.exectext(self.currentlayout.getAttribute("action"))

        self.mainwindow.set_title("Tapir: " +
                                  self.currentlayout.getAttribute("title"))

    def action(self, widget):
        for widgetnode in self.currentlayout.getElementsByTagName("widget"):
            if widget is self.getwidget(widgetnode):
                if widgetnode.hasAttribute("action"):
                    try:
                        self.layoutaction = True
                        self.exectext(widgetnode.getAttribute("action"), widget)
                    finally:
                        self.layoutaction = False
                if widgetnode.hasAttribute("next"):
                    self.setlayout(widgetnode.getAttribute("next"))
        

