import os
import configobj
import validate

class Config(object):
    # todo: compulsory attributes
    
    def __init__(self, main, defaults={}):
        object.__init__(self)
        self.config = configobj.ConfigObj(os.path.expanduser("~/.tapirrc"),
                                          configspec="tapirrc.val")
        print "validation:", self.config.validate(validate.Validator())
        self.main = main
#         self.defaults = {}
        self.constructed = True

#     def __new__(cls, *args, **kwargs):
#         obj = object.__new__(cls, *args, **kwargs)
#         obj.__constructed__ = True
#         print "obj.__dict__ = " + str(obj.__dict__)
#         return obj

    def callsetter(self, attrname, value):
        print "setting", attrname, "to", value
        try:
            setter = getattr(self.main, "set_" + attrname)
        except AttributeError:
            pass
        else:
            print "calling set_" + attrname
            setter(value)
    
    def __setattr__(self, attrname, value):
        if "constructed" not in self.__dict__:
            print "setting real attribute '%s'" % attrname
            self.__dict__[attrname] = value
        else:
            self.callsetter(attrname, value)  
            self.config[attrname] = value   # always, or at least when the
                                            # getter is not defined

    def __getattr__(self, attrname):
        try:
            method = getattr(self.main, "get_" + attrname)
        except AttributeError:
            return self.config[attrname]
        else:
            return method()

    def loadattr(self, attrname):
        setattr(self, attrname, self.config[attrname])

    def load(self):
        for attr in self.config:
            self.loadattr(attr)
#         for attr in self.defaults:
#             if attr not in self.config:
#                 self.callsetter(attr, self.defaults[attr])

    def save(self):
        print "saving!", self.__dict__
        for attr in self.config:
            self.config[attr] = getattr(self, attr)
        self.config.write()


class TapirConfig(Config):
    posprefix = "_position"
    
    def __setattr__(self, attr, value):
        print "config: setting '%s' to '%s'" % (attr, str(value))
        if attr.endswith(self.posprefix):
            widgetname = attr[:-len(self.posprefix)]
            print "config: %s.set_position(%i)" % (widgetname, value)
            self.main.widget(widgetname).set_position(value)
        else:
            Config.__setattr__(self, attr, value)

    def __getattr__(self, attr):
        print "config: getting '%s'" % attr
        if attr.endswith(self.posprefix):
            widgetname = attr[:-len(self.posprefix)]
            print "config: %s.get_position()" % widgetname
            return self.main.widget(widgetname).get_position()
        else:
            return Config.__getattr__(self, attr)
